<template lang="pug">

.login(v-loading="loginLoad")
  .block-typical
    .login__header
      h3 Авторизация

    el-form(
      v-if="stateForm"
      ref='loginForm'
      :model='stateForm'
      :rules="rules")

      el-form-item(
        v-for="item in loginForm"
        :key="item.id"
        :prop="item.name")

        app-input(
          :placeholder="item.placeholder"
          :model="item.model"
          :name="item.name"
          :id="item.id"
          :submitFunc="onSubmit"
          :type="item.type"
          :label="item.label"
          :required="item.required"
          :formRef="'loginForm'"
          @input-value="modelValue")

    .login__buttons-wrapper
      el-button.button(
        type="primary"
        @click="onSubmit('loginForm')"
        :disabled="!buttonConditionDisabled")
        |Войти

</template>
<script>
import InputItem from '../../components/InputItem';
import * as Cookies from 'js-cookie';

export default {
  layout: 'login',
  name: 'LoginPage',
  components: {
    'app-input': InputItem
  },
  data() {
    return {
      loginLoad: false,
      remembered: true,
      loginForm: [
        {
          id: 1,
          placeholder: 'Ведите email',
          model: '',
          label: 'Email',
          required: true,
          name: 'login',
          prop: [
            {
              required: true,
              message: 'Пожалуйста, введите email',
              trigger: 'change'
            },
            {
              type: 'email',
              message: 'Пожалуйста, укажите верный email',
              trigger: 'change'
            }
          ]
        },
        {
          id: 2,
          placeholder: 'Не менее 4-х символов',
          model: '',
          label: 'Пароль',
          required: true,
          name: 'password',
          type: 'password',
          prop: [
            {
              required: true,
              message: 'Пожалуйста, введите пароль',
              trigger: 'change'
            },
            { min: 4, message: 'Пароль не менее 4 символов', trigger: 'change' }
          ]
        }
      ]
    };
  },
  computed: {
    stateForm() {
      let state = {};
      this.loginForm.forEach(item => {
        state[item.name] = item.model;
      });
      return state;
    },
    rules() {
      let rulesObj = {};
      this.loginForm.forEach(item => {
        rulesObj[item.name] = item.prop;
      });
      return rulesObj;
    },
    buttonConditionDisabled() {
      let keys = Object.keys(this.stateForm);
      let stateFormInputFull = [];
      keys.forEach(key => {
        if (this.stateForm[key].length) {
          stateFormInputFull.push(true);
        } else if (stateFormInputFull.length) {
          stateFormInputFull.pop();
        }
      });
      return stateFormInputFull.length
        ? keys.length === stateFormInputFull.length
        : false;
    }
  },
  methods: {
    modelValue(valueArr) {
      let index = this.loginForm.findIndex(item => item.id === valueArr[0]);
      this.loginForm[index].model = valueArr[1];
      this.stateForm[this.loginForm[index].name] = valueArr[1];
    },
    onSubmit(formName) {
      this.$refs[formName].validate(valid => {
        if (valid) {
          this.loginLoad = true;
          this.$axios
            .post('/api/v1/login', {
              email: this.stateForm.login,
              password: this.stateForm.password
            })
            .then(
              response => {
                if (response.data.user.role === 'admin') {
                  Cookies.set('__a_t', response.data.cookies.access_token);
                  Cookies.set('__r_t', response.data.cookies.refresh_token);
                  this.$store.commit('userAuth', true);
                  this.$store.commit('adminAuth', true);
                  this.$store.commit('user', response.data.user);
                  this.loginLoad = false;
                  this.$message.success('Успешная авторизация в системе!');
                  this.$router.push({ path: '/admin' });
                } else {
                  this.loginLoad = false;
                  this.$message.error(
                    'Ошибка доступа! Недостаточно прав, обратитесь к администратору.'
                  );
                }
              },
              errorMessage => {
                console.log(errorMessage);
                this.$message.error(
                  'Неверный логин или пароль! Проверьте правильность вводимых данных.'
                );
                this.loginLoad = false;
              }
            )
            .catch(() => {
              this.$message.error('Ошибка проверки подлинности пользователя!');
              this.loginLoad = false;
            });
        } else {
          this.$message.error(
            'Пожалуйста, заполните форму авторизации корректно!'
          );
          return false;
        }
      });
    }
  }
};
</script>
